<?php
/*******************************************************************************
*  Programmed by: Ing. Alojz Bendak April 2010                                 *
*  Added gaph legend October 2013                                              *
*  Added property - draw_border                                                *
*  Added property - truecolor  19.11.2013                                      *
********************************************************************************/

  /*
  $values = array(
                  array('x1',10,'popis hodnoty 1','aa','#FF00FA'),
                  array('x1',10,array('popis','hodnoty 1'),'aa'),
                  array('x2',20,'popis hodnoty 2',array('bb','bc'),'#FF0000'),
                  array('x3',30,'popis hodnoty 3','cc','#11FF00')
                  );
  or
  $values = array(
                  array('x1', // grupped values into the one bar ...
                        array(10,'popis hodnoty 1','aa','#FF00FA'),
                        array(20,'popis hodnoty 2','bb','#FF0000'),
                        array(30,'popis hodnoty 3','cc','#11FF00')
                       ),
                  array('x2',
                        array(40,'popis hodnoty 4','dd','#FF00FA'),
                        array(50,'popis hodnoty 5','ee','#FF0000'),
                        array(60,'popis hodnoty 6','ff','#11FF00')
                       )                          
                  );   

  $graph = new CGraph3D(400,200);

  $graph->xtext = 'Pos.';
  $graph->ytext = 'Repair time [min]';
  $graph->headertext = "Repair time: $time_summary min";
  $graph->headerfontsize = 14;

  $graph->label_direction = 'horizontal';          
  $graph->label_vertical_align = 'over';
  $graph->label_horizontal_align = 'center';
  $graph->label_color = '#E1FFE1';
  $graph->label_showshadow = true;
  $graph->label_movey = -2;    
  
  //$graph->bar_random_color = true;
  $graph->gradienteffect = true;
  $graph->effect3D = true;
  $graph->graphangle = 35;
  $graph->zwidth = 15;
  $graph->values = $values;
  $graph->Draw_graph();
  $graph->Putintobuffer();
  
  $graph = null;                                         
  */
  
  // path TTF font directory...
  DEFINE('FONTDIR', "C:/windows/fonts/arial.ttf");
  
  DEFINE('DIRECTION_HORIZ', 'horizontal');
  DEFINE('DIRECTION_VERT', 'vertical');
  
  DEFINE('LABEL_VERTICAL_ALIGN_OVER', 'over');  
  DEFINE('LABEL_VERTICAL_ALIGN_TOP', 'top');
  DEFINE('LABEL_VERTICAL_ALIGN_MIDDLE', 'middle');
  DEFINE('LABEL_VERTICAL_ALIGN_BOTTOM', 'bottom');
  
  DEFINE('LABEL_HORIZONTAL_ALIGN_LEFT', 'left');  
  DEFINE('LABEL_HORIZONTAL_ALIGN_CENTER', 'center');
  DEFINE('LABEL_HORIZONTAL_ALIGN_RIGHT', 'right');  

  class CGraph3D
  {
    private $truecolor; // allocate graph for true colors ...
    private $image;     // img handler ...
    private $_background_color;        
    private $_line_color;
    private $_text_color;
    private $_bar_color;
    private $_label_color;
    private $_label_textcolor;    
    private $_barlabel_color;
    private $_barlabel_textcolor;    
    private $_shadow_color;    
    private $zy;
    private $zx;
    
    public $xtext; // text under x axis ...
    public $ytext; // text by y axis ...
    public $headertext; // graph header text ...
    public $headerfontsize; // font header ....
    public $footertext; // graph footer text ...
    public $footerfontsize; // font footer ....    
    public $values; // values for the graph ...
    public $legend_values; // values for the legend ...
    
    public $imagewidth;
    public $imageheight;
    public $graphwidth;
    public $graphheight;
    public $graphblank;
    public $textblank;
    public $graphangle; // angle of 3D effect ...
    public $zwidth;
    
    public $background_color;
    public $draw_border;
    public $line_color;
    public $text_color;
    public $bar_color;

    public $label_color;
    public $label_textcolor;
    public $label_direction;
    public $label_vertical_align;
    public $label_horizontal_align;
    public $label_showborder;
    public $label_showshadow;
    public $label_movex; // in case when user wants to move label in horizontal direction ...
    public $label_movey; // in case when user wants to move label in vertical direction ...
    
    public $barlabel_color;
    public $barlabel_textcolor;
    public $barlabel_direction;
    public $barlabel_vertical_align;
    public $barlabel_horizontal_align;
    public $barlabel_showborder;
    public $barlabel_showshadow;
    public $barlabel_movex; // in case when user wants to move barlabel in horizontal direction ...
    public $barlabel_movey; // in case when user wants to move barlabel in vertical direction ...    
    
    public $shadow_color;
    public $bar_random_color;
    public $gradienteffect;
    public $effect3D;
    public $show_yvalue;
    public $dualbars;
   
    public function __construct($width, $height, $truecolor = false)
    {
      $this->xtext = $this->ytext = '';
      $this->values = $this->legend_values = array();
    
      $this->truecolor = $truecolor;
      $this->imagewidth = $width;
      $this->imageheight = $height;
      
      $this->graphblank = 25;
      $this->textblank = 3;
      $this->graphwidth = $this->imagewidth - 2 * $this->graphblank;
      $this->graphheight = $this->imageheight - 2 * $this->graphblank;
      
      if ($this->truecolor)
        $this->image = @imagecreatetruecolor($width, $height) or die ("Cannot Initialize new GD image stream ".$this->imagewidth.' '.$this->imageheight);
      else
        $this->image = @imagecreate ($width, $height) or die ("Cannot Initialize new GD image stream ".$this->imagewidth.' '.$this->imageheight);
            
      $this->background_color = '#FFFFFF';
      $this->line_color = $this->text_color = '#000000';
      $this->bar_color = '#CC0033';      
      $this->shadow_color = '#444444';

      $this->headertext = '';
      $this->headerfontsize = 18;
      $this->footertext = '';
      $this->footerfontsize = 12;      
      
      $this->graphangle = 30;
      $this->zwidth = 20;
      $this->zy = $this->zx = 0;      
      
      $this->label_showborder = true;
      $this->label_direction = DIRECTION_HORIZ;
      $this->label_color = $this->background_color; 
      $this->label_textcolor = $this->text_color;
      $this->label_vertical_align = LABEL_VERTICAL_ALIGN_TOP;
      $this->label_horizontal_align = LABEL_HORIZONTAL_ALIGN_CENTER;
      $this->label_showshadow = true;
      $this->label_movex = $this->label_movey = 0;
      
      $this->barlabel_showborder = true;
      $this->barlabel_direction = DIRECTION_HORIZ;
      $this->barlabel_color = $this->background_color;
      $this->barlabel_textcolor = $this->text_color;
      $this->barlabel_vertical_align = LABEL_VERTICAL_ALIGN_OVER;
      $this->barlabel_horizontal_align = LABEL_HORIZONTAL_ALIGN_CENTER;      
      $this->barlabel_showshadow = true;
      $this->barlabel_movex = $this->barlabel_movey = 0;
      
      $this->bar_random_color = $this->gradienteffect = $this->show_yvalue = false;
      $this->effect3D = true;
      $this->dualbars = false;
      $this->draw_border = true;
    }

    public function __destruct()
    {
      $this->values = 
      $this->legend_values = null;
      imagedestroy ($this->image);
      $this->image = null;
    }

    private function Split_color($color, &$r, &$g, &$b) { $r = hexdec(substr($color, 1, 2)); $g = hexdec(substr($color, 3, 2)); $b = hexdec(substr($color, 5)); return null; }
    private function Transform_color($color) { $this->Split_color($color, $r, $g, $b); return imagecolorallocate ($this->image, $r, $g, $b); }
    private function Get_random_color() { return '#'.dechex(rand(0, 255)).dechex(rand(0, 255)).dechex(rand(0, 255)); }
    private function Check_color($color){ if ($color < 0) $color = 0; elseif ($color > 255) $color = 255; return $color; }
    private function Get_shadow_color($color, $level)
    {
      $this->Split_color($color, $r, $g, $b);
      if     ($r == $g && $r == $b) { $r = $this->Check_color($r += $level); $g = $this->Check_color($g += $level); $b = $this->Check_color($b += $level); }
      elseif ($r > $g && $r > $b) $r = $this->Check_color($r += $level);
      elseif ($g > $r && $g > $b) $g = $this->Check_color($g += $level);
      elseif ($b > $r && $b > $g) $b = $this->Check_color($b += $level); 
      elseif ($r == $g && $r > $b) { $r = $this->Check_color($r += $level); $g = $this->Check_color($g += $level); }
      elseif ($r == $b && $r > $g) { $r = $this->Check_color($r += $level); $b = $this->Check_color($b += $level); }  
      elseif ($b == $g && $b > $r) { $b = $this->Check_color($b += $level); $g = $this->Check_color($g += $level); }
      return imagecolorallocate ($this->image, $r, $g, $b);
    }    

    private function Draw_header()
    {
      $a = imagettfbbox($this->headerfontsize, 0, FONTDIR, $this->headertext);
      $w = $a[2] - $a[0];
      $h = $a[3] - $a[1];
      return imagettftext($this->image, $this->headerfontsize, 0, floor(($this->imagewidth - $w) / 2), 30, $this->_text_color, FONTDIR, $this->headertext);
    }
    
    private function Draw_centered_text($text, $left, $width, $top, $fontsize, $textcolor)
    {
      return imagestring($this->image, $fontsize, $left + round(($width - strlen($text) * imagefontwidth($fontsize)) / 2), $top, $text, $textcolor);
    }

    private function Draw_label($left, $width, $top, $height, $labelcolor, $showshadow, $shadowcolor)
    {
      $shadowstep = 2;
      // shadow ...
      if ($showshadow)
        imagefilledrectangle($this->image, $left + $shadowstep, $top + $shadowstep, $left + $width + $shadowstep, $top + $height + $shadowstep, $shadowcolor);
      // label ...
      imagefilledrectangle($this->image, $left, $top, $left + $width, $top + $height, $labelcolor);
      imagerectangle($this->image, $left, $top, $left + $width, $top + $height, $this->_line_color);
    }

    private static function Is_diffline($line)
    {
      $line = trim($line);
      for ($i = 0; $i < strlen($line); $i++) 
      	if ($line{$i} != '-') 
          return false;
      return true;
    }  
          
    private function Draw_text($text, $left, $width, $top, $height, $fontsize, $labelcolor, $textcolor, $showborder = false, 
      $direction = DIRECTION_HORIZ, $label_vertical_align = LABEL_VERTICAL_ALIGN_TOP, $label_horizontal_align = LABEL_HORIZONTAL_ALIGN_CENTER, $showshadow = true)
    {
      if (is_array($text))
      {
        if (count($text) == 0) return true;
      }
      else
      {
        if ($text == '') return true;
        $text = array($text);
      }

      $fontheight = imagefontheight($fontsize);
      $fontwidth = imagefontwidth($fontsize);
      $maxwidth = $maxheight = 0;      
      foreach ($text as $line) 
      {
        $line = " $line ";
        $linewidth = $fontwidth * strlen($line);
        if ($direction == DIRECTION_HORIZ)
        {
          if ($linewidth > $maxwidth) $maxwidth = $linewidth;
          $maxheight += $this->Is_diffline($line) ? $this->textblank : $fontheight;
        }
        else // vertical direction ...
        {
          if ($linewidth > $maxheight) $maxheight = $linewidth;
          $maxwidth += $this->Is_diffline($line) ? $this->textblank : $fontheight;          
        }  	
      }
    
      switch ($label_vertical_align)
      {
        case LABEL_VERTICAL_ALIGN_OVER:   $labeltop = $top - $maxheight - 2;                                                            break;         
        case LABEL_VERTICAL_ALIGN_TOP:    $labeltop = $top;                                                                             break;            
        case LABEL_VERTICAL_ALIGN_MIDDLE: $labeltop = $top + round(($height - $maxheight) / 2);                                         break;
        case LABEL_VERTICAL_ALIGN_BOTTOM: $labeltop = $top + $height - $maxheight + ($showborder && $showshadow ? $this->textblank : 0);break;
      }
      $labelheight = $maxheight;        
      switch ($label_horizontal_align)
      {
        case LABEL_HORIZONTAL_ALIGN_LEFT:   $labelleft = $left;                                   break;        
        case LABEL_HORIZONTAL_ALIGN_CENTER: $labelleft = $left + round(($width - $maxwidth) / 2); break;
        case LABEL_HORIZONTAL_ALIGN_RIGHT:  $labelleft = $left + $width - $maxwidth;              break;
      }            
      $labelwidth = $maxwidth;

      if ($showborder) $this->Draw_label($labelleft, $labelwidth, $labeltop, $labelheight, $labelcolor, $showshadow, $this->_shadow_color);
        
      if ($direction == DIRECTION_HORIZ)
      {
        foreach ($text as $line) 
        {          
          if ($this->Is_diffline($line)) $labeltop -= 2 * $this->textblank;
          $this->Draw_centered_text(" $line ", $labelleft, $labelwidth, $labeltop, $fontsize, $textcolor);
          if ($this->Is_diffline($line)) $labeltop -= 2 * $this->textblank;
          $labeltop += $fontheight; 
        } 
      }
      else // vertical direction ...
      {          
        foreach ($text as $line) 
        {
          if ($this->Is_diffline($line)) $labelleft -= 2 * $this->textblank;
          $line = " $line ";
          imagestringup($this->image, $fontsize, $labelleft, $labeltop + $labelheight - round(($labelheight - strlen($line) *  $fontwidth) / 2), $line, $textcolor);
          if ($this->Is_diffline($line)) $labelleft -= 2 * $this->textblank;          
          $labelleft += $fontheight; 
        }               
      }
    }    

    // draws 3D bar in the graph, barcolor - RGB format ...
    private function Draw_3Dbar($left, $top, $width, $height, $barcolor = '')
    {
      if ($barcolor == '')
      {
        if ($this->bar_random_color)
        {
          $barcolor = $this->Get_random_color();
          $_barcolor = $this->Transform_color($barcolor);
        }
        else
        {      
          $barcolor = $this->bar_color;
          $_barcolor = $this->_bar_color;
        }  
      }
      else
      {
        $_barcolor = $this->Transform_color($barcolor);
      }  
         
      imagefilledrectangle($this->image, $left, $top, $left + $width, $top + $height, $_barcolor);
      imagerectangle($this->image, $left, $top, $left + $width, $top + $height, $this->_line_color);
      
      $points = array($left,  $top, $left + $this->zx,  $top - $this->zy, $left + $this->zx + $width,  $top - $this->zy, $left + $width, $top);
      imagefilledpolygon($this->image, $points, 4, $c = $this->Get_shadow_color($barcolor, -60));
//imagecolordeallocate($this->image, $c); $c = null;
      imagepolygon($this->image, $points, 4, $this->_line_color);
      
      $points = array($left + $width, $top, $left + $width, $top + $height, $left + $width + $this->zx, $top + $height - $this->zy, $left + $width + $this->zx,  $top - $this->zy);
      imagefilledpolygon($this->image, $points, 4, $c = $this->Get_shadow_color($barcolor, -30));
//imagecolordeallocate($this->image, $c); $c = null;      
      imagepolygon($this->image, $points, 4, $this->_line_color);      
    }
    
    private function Draw_bar($gradienteffect, $left, $top, $width, $height, $barcolor = '')
    {
      if ($barcolor == '')
      {
        if ($this->bar_random_color)
        {
          $barcolor = $this->Get_random_color();
          $_barcolor = $this->Transform_color($barcolor);
        }
        else
        {      
          $barcolor = $this->bar_color;
          $_barcolor = $this->_bar_color;
        }  
      }
      else
        $_barcolor = $this->Transform_color($barcolor);
          
      if ($gradienteffect)
      {
        $this->Split_color($barcolor, $r, $g, $b);
        $count = $width / 2;
        $r_interval = (255 - $r) * 0.75;
        $g_interval = (255 - $g) * 0.75;
        $b_interval = (255 - $b) * 0.75;
        $l = $left;
        $th = $top + $height;
        $step = 3;
        $colors = array();
        for ($x = 0; $x < $count; $x += $step)
        {
          $p = $x / $count;
          $r_= $r + floor($p * $r_interval);
          $g_= $g + floor($p * $g_interval);
          $b_= $b + floor($p * $b_interval);
          $color = imagecolorallocate ($this->image, $r_, $g_, $b_);
          $colors[] = $color;
        	imagefilledrectangle($this->image, $l, $top, $l + $step - 1, $th, $color);
        	$l += $step;
        }
        $index = count($colors);
        for ($x = $count; $x > 0; $x -= $step)
        {
          imagefilledrectangle($this->image, $l, $top, $l + $step - 1, $th, $colors[--$index]);
        	$l += $step;
//imagecolordeallocate($this->image, $colors[$index]); $colors[$index] = null;
        }
      }
      else
      {
        imagefilledrectangle($this->image, $left, $top, $left + $width, $top + $height, $_barcolor);
        imagerectangle($this->image, $left, $top, $left + $width, $top + $height, $this->_line_color);
      }  
      return false;
    }
    
    public function Draw_graph()
    {
      if ($this->footertext > '')
        $this->graphheight -= imagefontheight($this->footerfontsize);
          
      $angle = ($this->graphangle / 180) * pi();
      $this->zy = round($this->zwidth * sin($angle), 0);
      $this->zx = round($this->zwidth * cos($angle), 0);
      
      // Transform colors ....
      $this->_background_color = $this->Transform_color($this->background_color);
      $this->_label_color = $this->Transform_color($this->label_color);
      $this->_label_textcolor = $this->Transform_color($this->label_textcolor);
      $this->_barlabel_color = $this->Transform_color($this->barlabel_color);
      $this->_barlabel_textcolor = $this->Transform_color($this->barlabel_textcolor);
      $this->_line_color = $this->Transform_color($this->line_color);
      $this->_text_color = $this->Transform_color($this->text_color);
      $this->_shadow_color = $this->Transform_color($this->shadow_color);
      $this->_bar_color = $this->Transform_color($this->bar_color);

      // draw background ...
      // border graph ...
      if ($this->truecolor)
      {
        $points = array(0, 0,
                        0, $this->imageheight,
                        $this->imagewidth, $this->imageheight,
                        $this->imagewidth, 0);      
        imagefilledpolygon($this->image, $points, 4, $this->_background_color);
      }
      else
      {         
        imagerectangle($this->image, 0, 0, $this->imagewidth, $this->imageheight, $this->_background_color);
      }  
      
      // border ...
      if ($this->draw_border)
      {
        imageline($this->image,                     0,                      0,                     0,     $this->imageheight, $this->_line_color);
        imageline($this->image,                     0, $this->imageheight - 1,     $this->imagewidth, $this->imageheight - 1, $this->_line_color);
        imageline($this->image, $this->imagewidth - 1, $this->imageheight - 1, $this->imagewidth - 1,                      0, $this->_line_color);
        imageline($this->image,     $this->imagewidth,                      0,                     0,                      0, $this->_line_color);
      }  
      
      // axes x, y ...
      $fontsize = 2;
                         
      // X...
      $xtext = $this->xtext;
      imagestring($this->image, $fontsize, $this->graphwidth + $this->textblank, $this->graphblank + $this->graphheight + $this->textblank, $xtext, $this->_text_color);
      if ($this->effect3D)
      {      
        $points = array($this->graphblank, $this->graphblank,
                        $this->graphblank, $this->graphblank + $this->graphheight,
                        $this->graphblank + $this->zx, $this->graphblank + $this->graphheight - $this->zy,
                        $this->graphblank + $this->zx, $this->graphblank -$this->zy);      
        imagefilledpolygon($this->image, $points, 4, $shadowcolor = $this->Get_shadow_color($this->background_color, -20));      
        imagepolygon($this->image, $points, 4, $this->_line_color);
      }
      else
        imageline($this->image, $this->graphblank, $this->graphblank, $this->graphblank, $this->graphheight + $this->graphblank, $this->_line_color);      

      // Y...
      $ytext = $this->ytext;
      imagestringup($this->image, $fontsize, $this->graphblank - imagefontheight($fontsize) - $this->textblank, strlen($ytext) * imagefontwidth($fontsize) + $this->graphblank, $ytext, $this->_text_color);
      if ($this->effect3D)
      {      
        $points = array($this->graphblank, $this->graphblank + $this->graphheight,
                        $this->graphblank + $this->graphwidth, $this->graphblank + $this->graphheight,
                        $this->graphblank + $this->graphwidth + $this->zx, $this->graphblank + $this->graphheight - $this->zy,
                        $this->graphblank + $this->zx, $this->graphblank + $this->graphheight - $this->zy);
        imagefilledpolygon($this->image, $points, 4, $shadowcolor);      
        imagepolygon($this->image, $points, 4, $this->_line_color);
//imagecolordeallocate($this->image, $shadowcolor); $shadowcolor = null;
      }
      else
        imageline($this->image, $this->graphblank, $this->graphblank + $this->graphheight, $this->graphblank + $this->graphwidth, $this->graphblank + $this->graphheight, $this->_line_color);
                    
      // Draw header ...
      $this->Draw_header();
      
      // Draw values ...
      $count = count($this->values);
      if ($count > 0)
      {
        // find max value for the graph bar ...      
        $maxvalue = 0.0;
        foreach ($this->values as $values)
        {
          if (is_array($values[1]))
          {
            $sumv = 0.0;
            for ($i = 1; $i < count($values); $i++) $sumv += $values[$i][0];
            $value = (double) $sumv;            
          }
          else
            $value = (double) $values[1];
            
          if ($value > $maxvalue) $maxvalue = $value;
        }  
          
        if ($maxvalue > 0)
        {
          $barindex = 0;
          $maxbarheight = $this->graphheight - $this->graphblank;
          $p = 0.4;
          if ($this->dualbars) // left position of bars depends on "dualbars" parameter ...
            $barwidth = floor($this->graphwidth / ($count + $p * (ceil($count/2) + 1)));
          else
            $barwidth = floor($this->graphwidth / ($count + $p * ($count + 1)));
          $barblank = floor($barwidth * $p);  
          $fontsize = 2;
          $barleft = $this->graphblank + $barblank;
          $xtop = $this->graphblank + $this->graphheight + $this->textblank;                    
          foreach ($this->values as $values)
          {
            $barindex++;
            
            if (is_array($values[1]))
            { 
              $values_count = count($values);
              // how many texts for one column ...
              $text_count = 0;
              $labeltext = '';
              // count sum value of all bar items ...
              $yvalue = 0.0;
              for ($i = 1; $i < $values_count; $i++)
              { 
                $item = $values[$i]; 
                $yvalue += $item[0];
                if ($item[1] > '') 
                {
                  $text_count++;
                  $labeltext = $item[1];                
                }
              }
                       
              $xvalue = $values[0];
                              
              // draw graph bars ...
              $bartop = 2 * $this->graphblank + $maxbarheight;                                
              for ($i = 1; $i < $values_count; $i++)
              {
                $item = $values[$i]; 
                $val = $item[0];
                // draws bar ...            
                $barheight = $yvalue != 0 ? floor(($yvalue / $maxvalue) * $maxbarheight * ($val / $yvalue)) : 0;
                $bartop -= $barheight;
                if ($this->effect3D)
                  $this->Draw_3Dbar($barleft, $bartop, $barwidth, $barheight, $item[3]);
                else
                  $this->Draw_bar($this->gradienteffect, $barleft, $bartop, $barwidth, $barheight, $item[3]);  
              }
              
              // draw labels ...
              if ($values_count > 2 && $text_count == 1) // one label only, even if more then one items exist ... 
              {
                $this->Draw_text($labeltext, $barleft + $this->label_movex, $barwidth, 2 * $this->graphblank + $this->label_movey, $maxbarheight, $fontsize, $this->_label_color, $this->_label_textcolor, 
                  $this->label_showborder, $this->label_direction, $this->label_vertical_align, $this->label_horizontal_align, $this->label_showshadow);
              }
              $bartop = 2 * $this->graphblank + $maxbarheight;
              $last_labeltop = $last_labelheight = 0;
              for ($i = 1; $i < $values_count; $i++) 
              {
                $item = $values[$i];
                $val = $item[0];
                $barheight = $yvalue != 0 ? floor(($yvalue / $maxvalue) * $maxbarheight * ($val / $yvalue)) : 0;
                $bartop -= $barheight;
                // text label ...
                if (($labeltext = $item[1]) > '' &&  // if filled, draw the text by value ...
                    !($values_count > 2 && $text_count == 1)  // if the text is one for all items, do not draw it in this place ...
                   )
                  $this->Draw_text($labeltext, $barleft + $this->label_movex, $barwidth, $bartop + $this->label_movey, $barheight, $fontsize, $this->_label_color, $this->_label_textcolor, 
                    $this->label_showborder, $this->label_direction, $this->label_vertical_align, $this->label_horizontal_align, $this->label_showshadow);
                
                // bar label ...                
                if ($val && ($bartext = $item[2]) > '') // if filled, draw the bartext with one or more lines ...
                {
                  $_top = $bartop + $this->barlabel_movey;
                  // only for alternating moving the top of labels due to covering
                  if ($i % 2) 
                    $_top -= 5;
                  else  
                    $_top += 5;

                  $this->Draw_text($bartext, $barleft + $this->barlabel_movex, $barwidth, $_top, $barheight, $fontsize, $this->_barlabel_color, $this->_barlabel_textcolor, 
                    $this->barlabel_showborder, $this->barlabel_direction, $this->barlabel_vertical_align, $this->barlabel_horizontal_align, $this->barlabel_showshadow);
                }    
                // axis part y value ...
                if ($this->show_yvalue)
                  $this->Draw_centered_text($val, $barleft, $barwidth, round($bartop + $barheight / 2 - imagefontheight($fontsize)), $fontsize, $this->_text_color);                                   
              } 
            }
            else
            {
              $xvalue = $values[0]; $yvalue = $values[1]; $labeltext = $values[2]; $bartext = $values[3]; $barcolor = $values[4];
              // draws bar ...            
              $barheight = floor($maxbarheight * ($yvalue / $maxvalue));
              $bartop = 2 * $this->graphblank + $maxbarheight - $barheight;
              if ($this->effect3D)                
                $this->Draw_3Dbar($barleft, $bartop, $barwidth, $barheight, $barcolor);
              else  
                $this->Draw_bar($this->gradienteffect, $barleft, $bartop, $barwidth, $barheight, $barcolor);

              if ($labeltext > '') // if filled, draw the text by value ...
                $this->Draw_text($labeltext, $barleft + $this->label_movex, $barwidth, $bartop + $this->label_movey, $barheight, $fontsize, $this->_label_color, $this->_label_textcolor, 
                  $this->label_showborder, $this->label_direction, $this->label_vertical_align, $this->label_horizontal_align, $this->label_showshadow);

              if ($bartext > '') // if filled, draw the bartext with one or more lines ...
                $this->Draw_text($bartext, $barleft + $this->barlabel_movex, $barwidth, $bartop + $this->barlabel_movey, $barheight, $fontsize, $this->_barlabel_color, $this->_barlabel_textcolor, 
                   $this->barlabel_showborder, $this->barlabel_direction, $this->barlabel_vertical_align, $this->barlabel_horizontal_align, $this->barlabel_showshadow);
            }    
            
            // axis x value ...
            $this->Draw_centered_text($xvalue, $barleft, $barwidth, $xtop, $fontsize, $this->_text_color);

            // axis y total value ...
            if ($this->show_yvalue)
              $this->Draw_centered_text($yvalue, $barleft, $barwidth, $bartop - imagefontheight($fontsize) - $this->textblank, $fontsize, $this->_text_color);
                    
            if ($this->dualbars) // left position of bars depends on "dualbars" parameter ...
            {
              if ($barindex % 2)
                $barleft += $barwidth;
              else  
                $barleft += $barwidth + $barblank;
            }  
            else                            
              $barleft += $barwidth + $barblank;            
          }
        }
      }
      
      if ($this->footertext > '')
        $this->Draw_centered_text($this->footertext, 0, $this->imagewidth, $this->graphheight + $this->graphblank + imagefontheight($fontsize), $this->footerfontsize, $this->_text_color);
      
      // draw graph legend ...  
      if (is_array($this->legend_values))
      {
        $c = count($this->legend_values);
        $maxlen = 0; 
        foreach ($this->legend_values as $legendvalue) 
        {
          $l = strlen($legendvalue[0]);
          if ($maxlen < $l) $maxlen = $l;
        }

        $fontheight = imagefontheight($fontsize);
        $fontwidth = imagefontwidth($fontsize);
        $legendheight = $c * $fontheight + ($c + 1) * $this->textblank;
        $legendwidth = $this->textblank + $fontheight + $this->textblank + $maxlen * $fontwidth + $this->textblank;
        $legendtop = round(($this->imageheight - $legendheight) / 2) - $this->graphblank;            
        $legendleft = $this->imagewidth - $this->graphblank - $legendwidth;
        // draw legend area ...
        $points = array($legendleft, $legendtop, 
                        $legendleft + $legendwidth, $legendtop, 
                        $legendleft + $legendwidth, $legendtop + $legendheight, 
                        $legendleft, $legendtop + $legendheight);
        imagefilledpolygon($this->image, $points, 4, $this->_background_color);      
        imagepolygon($this->image, $points, 4, $this->_line_color);
        // draw legend items ...         
        $legendtexttop = $legendtop + $this->textblank;  
        $legendtextleft = $legendleft + $this->textblank + $fontheight + $this->textblank;
        foreach ($this->legend_values as $legendvalue) 
        { 
          $legendtext = $legendvalue[0];         
        	$legendcolor = $this->Transform_color($legendvalue[1]);
          $points = array($legendleft + $this->textblank, $legendtexttop, 
                          $legendleft + $this->textblank + $fontheight, $legendtexttop, 
                          $legendleft + $this->textblank + $fontheight, $legendtexttop + $fontheight, 
                          $legendleft + $this->textblank, $legendtexttop + $fontheight);
          imagefilledpolygon($this->image, $points, 4, $legendcolor);      
          imagepolygon($this->image, $points, 4, $this->_line_color);
          $this->Draw_text($legendtext, $legendtextleft, strlen($legendtext) * $fontwidth, $legendtexttop, $fontheight, 
            $fontsize, $this->_label_color, $this->_label_textcolor, false, DIRECTION_HORIZ, LABEL_VERTICAL_ALIGN_TOP, LABEL_HORIZONTAL_ALIGN_CENTER, false);
          $legendtexttop += $fontheight + $this->textblank;    
        }
      }  
    }
    
    public function Putintobuffer()
    {
      header("Content-type: image/png");
      header("Cache-Control: no-cache, must-revalidate");
      imagepng ($this->image);
    }
  }
?>